%if style == newcode
\begin{code}
module Booleans(rewrite, bool) where
import VirtualMachine
import ObjectTheory
bool :: Value
\end{code}
%endif


%{
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\section{Booleans}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%\begin{itemize}
%\item cannot be derived from 
%\end{itemize}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{The boolean class}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{code}
bool = new
  [ __class__    |-> a_Type
  , __bases__    |-> a_objectT
  , __nonzero__  |-> Typed (Prim "bool" "__nonzero__") [a_bool]
  , __str__      |-> Typed (Prim "bool" "__str__") [a_bool]
  ]
\end{code}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{Literal booleans}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\rulesection{Evaluating a boolean literal}
\label{fw-rewrite-BoolExpr}
%format l_b
\begin{code}
rewrite  (State  ( heap                                )  env  stack  ( FwExpr    (BoolExpr b) )) =
         (state  ( heap `insert` [a |-> (BoolValue b)] )  env  stack  ( BwResult  a            ))
  where a = freeAddr heap
\end{code}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\subsection*{Boolean primitives}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\rulesection{The boolean to boolean conversion primitive}
\begin{code}
rewrite  (State  heap  env  stack  ( FwApp (Prim "bool" "__nonzero__") [a] )) =
         (state  heap  env  stack  ( BwResult a                            ))
\end{code}


\rulesection{The boolean to string conversion primitive}
\begin{code}
rewrite                     (State  heap  env  stack  ( FwApp (Prim "bool" "__str__") [a] ))
  | getBoolValue heap a  =  (state  heap  env  stack  ( FwExpr (StringExpr "True")        ))
  | otherwise            =  (state  heap  env  stack  ( FwExpr (StringExpr "False")       ))
\end{code}


%if style == newcode
\begin{code}
rewrite _ = skipState
\end{code}
%endif

%}
