#!/usr/bin/python
#This is the main executable Python program of the test suite. It executes the tests that are defined in separate files, i.e. modules.
import os
import sys

import TestReport
import Asserts

def len(x) :
    return x.__len__()

def tail(str, n) :
    #return str[len(str)-n:len(str)]

    i = str.__len__() - n
    lst = ""
    while i < str.__len__() :
        lst = lst + str[i]
        i = i + 1
    return lst

def pop(str) :
    i = 1
    lst = []
    while i < str.__len__() :
        lst = lst + [str[i]]
        i = i + 1
    return lst

def execTest(filepath, report) :

    # skip non-python files
    if tail(filepath, 3) == ".py" :
        pass
    else : 
        return None

    testfile = file(filepath)
    report.reportTestStart(filepath)
    # initialize a new testing environment
    env = Asserts.TestEnv(report) 
    try :
        try :
            exec testfile in env
        except report.expectedException, e :
            report.reportSuccess()
            return None
    except Exception, e : 
        report.reportFailure(e)
        return None
    
    if report.isExpectingException :
        report.reportFailure(report.expectedException)
    else :
        #TODO: create a proper exception to report!
        report.reportSuccess()


def execTests(path, tests, report) :
    for filename in tests :

        # skip rediculously short files
        if filename.__len__() < 3 :
            continue

        # skip hidden files and directories
        if filename[0] == "." :
            if filename[1] == "." :
                pass
            else :
                continue

        # get the complete path and file
        filepath = path + filename

        if os.path.isdir(filepath) :
            execTests(filepath + "/", os.listdir(filepath), report)
        else :
            execTest(filepath, report)


###########################################################################

defaultTests = [ "ifelse"
               , "for" 
               , "while" 
               , "nones" 
               , "numbers" 
               , "import" 
               , "attributes" 
               , "bools" 
               , "classes" 
               , "dict" 
               , "exceptions" 
               , "exec" 
               , "functions" 
               , "instantiation" 
               , "lists" 
               , "print" 
               , "strings" 
               , "generators"
               , "operators"
               ]

###########################################################################
report = TestReport.TestReport()

# execute the default tests if no arguments is supplied
if len(sys.argv) == 1 :
    execTests("", defaultTests, report)
else : # execute the tests supplied on the commandline
    execTests("", pop(sys.argv), report)

print("total no failures: " + report.failureCnt.__str__()
      + "/" + (report.successCnt + report.failureCnt).__str__())
